Maneira de eliminar comandos externos do script para gerar o checksum NMEA 0183 xor usando bash [closed]

0

Recentemente tive a necessidade de gerar e verificar checksums NMEA 0183 usando o bash e não consegui encontrar muita coisa escrita para realizar exatamente o que eu precisava.

As sentenças NMEA 0183 começam com um $ e terminam com um * e dois caracteres que são um hex xor de todos os bytes entre o $ e o *. Exemplo:

$INGGA,230501.547,2118.97946,N,15752.60495,W,2,08,1.1,5.17,M,,,0,0001*02

Este utilitário irá converter uma string para hex e xor. Ele pode ser usado para verificar somas de verificação já existentes ou gerar somas de verificação para o final das sentenças NMEA que você está gerando (remove as cadeias $ e * .. das cadeias que você as alimenta.)

#!/bin/bash

# =========================================================
# Reads a NMEA 0183 sentence and calculates the proper
# XOR checksum for the end.

# Will accept a string with or without a checksum on
# the end or $ on the front and calculate what the checksum
# should be.

# Sentence can be read as an argument but must be single quoted
# or preceded by a \ or the shell will try to interpret the
# talker as a variable and the result will be incorrect.
# Examples:

#     xor '$INHDT,207.7,T*27'
#     xor \$INHDT,207.7,T*27
#     xor INHDT,207.7,T

# If run with no arguments, will prompt user for data.  No
# quotes or backslash is needed then.

# Depends: xxd sed

# ===T.Young 09/2016=======================================

set -o pipefail
set -o errexit
set -o nounset

# Functions
# =========

depcheck() { # Checks that necessary external commands are present
             # and executable
    local DEPENDS="sed xxd"
    for PROG in $DEPENDS; do
        [[ -x "$(command -v $PROG)" ]] || {
            echo "$PROG MISSING!  Exiting."
            exit 0
            }
    done
    }

x_or() { # Here is where the magic happens
    # The next two lines strip out $ characters, or an
    # * and anything after it (checksum)
    HEAD="${SENTENCE%\**}"
    TAIL="${HEAD//\$}"

    # Convert ASCII string into hex and read into an array.
    # Each element in the array gets preceded by "0x"
    HEXVAL="$(xxd -pu <<< ${TAIL})"
    HEXARRAY=($(printf '%s' "${HEXVAL%0a}" | sed -e 's/../0x& /g'))

    # Loop through the array and do the xor, initially start $XOR at 0
    for (( x=0; x<"${#HEXARRAY[@]}"; x++ )); do
        XOR=0x$(printf '%02x' "$(( ${XOR:-0} ^ ${HEXARRAY[$x]} ))")
    done

    # Strip off the 0x from the result
    CLEAN=${XOR#0x}
    printf '%s\n' "${CLEAN^^}"
    }

main() {
    case "${1:-}" in
        "")  # No input specified, read from stdin
            depcheck
            read -r SENTENCE
            x_or
            ;;

        *) # Input was provided, use that
            depcheck
            SENTENCE="$1"
            x_or
            ;;
    esac
}

# Main
# ====

main "$@"

Quando faço o script de shell, sempre tento encontrar maneiras de eliminar o uso de programas externos, mesmo que sejam tão comuns quanto sed, ou xxd. Se alguém souber uma maneira de fazer o acima usando apenas builtins shell por favor, chime.

Atualização: Aqui está uma nova função levando em conta o método de Sato. Ele permite a eliminação completa de chamadas de programa externas e a função depcheck associada acima.

x_or() { # Create a hex XOR checksum of all the bytes
    # Clean the line of $ character and anything before it
    TAIL="${SENTENCE##*$}"
    HEAD=${TAIL%\**}
    LEN=${#HEAD}

    # Loop through the string and do the xor
    # initially start $XOR at 0
    XOR=0
    for (( x=0; x<$LEN; x++ )); do
        (( XOR^=$(printf '%d' "'${HEAD:$x:1}'") ))
    done

    printf '%02X\n' "${XOR}"
    }

Chame a função com "LC_CTYPE = C". Provavelmente ainda há mais que poderia ser feito aqui, mas isso é bastante sucinto.

    
por Trevor Young 23.09.2016 / 05:16

1 resposta

1

Pessoalmente, eu faria assim:

#! /usr/bin/env bash

log() {
    {
        printf '%s: ' "${0##*/}"
        printf "$@"
        printf '\n'
    } >&2
}


cksum() {
    tot=${#1}
    let len=tot-4

    let res=0
    while [ $len -gt 0 ]; do
        let res^=$( LC_CTYPE=C printf '%d' "'${1:$len:1}'" )
        let len--
    done

    let ptr=tot-2
    if [ x"$( printf '%s' "${1:$ptr}" | tr a-f A-F )" != x"$( printf '%02X' $res )" ]; then
        log '%s: invalid checksum (found %02X)' "$1" $res
    fi
}


check () {
    if expr "$2" : '\$.*\*[0-9a-fA-F][0-9a-fA-F]$' >/dev/null; then
        cksum "$2"
    else
        log 'invalid input on line %d: %s' "$1" "$2"
    fi
}


let cnt=0
if [ $# -ne 0 ]; then
    while [ $# -gt 0 ]; do
        let cnt++
        check $cnt "$1"
        shift
    done
else
    while read -r str; do
        let cnt++
        check $cnt "$str"
    done
fi

A linha shebang reivindica bash , mas ainda deve funcionar para ksh93r e zsh . Nenhuma dependência em xxd . Nenhuma alegação de ser um exemplo de estilo de script a ser seguido também. :)

    
por 23.09.2016 / 09:36